
//////// DesCode
//////// richard.dank@fh-joanneum.at
//////// http://richdank.com/theory/descode/
//////// first "greeking" experiment | erstes "greeking" experiment

/*
 * //////// predefined arrays you need to work with
 * int my_size     : number of symbols that will be generated and placed
 * char[] my_chars : list, that contains the generated symbol
 * float[] my_xs   : the corresponding x-position of the symbol within the grid
 * float[] my_ys   : the corresponding y-position of the symbol within the grid
 */

//////// setup
void setup() {
  size( 1280, 720 );
  //getArrays( getMin( my_size ) );
  //getArrays( getNum( my_size ) );
  //getArrays( getHex( my_size ) );
  //getArrays( getText( my_size, "de.txt" ) );
  getArrays( getText( my_size, "en.txt" ) );
  //getArrays( getLorem( my_size ) );
}

//////// draw
void draw() {
  //simpleDemo();
  //circleDemo();
  //////// basic display modes | grundsaetzliche darstellung
  background( 255 );
  textAlign( CENTER, CENTER );
  //////// all the characters | alle zeichen
  for( int i=0; i<my_chars.length; i++ ) {
    //////// get distance from mouse to character | abstand maus zum zeichen ermitteln
    float dis = dist( my_xs[i], my_ys[i], mouseX, mouseY );
    //////// text size from distance | textgroesse aus der distanz
    float siz = map( dis, 0, width/2, width/4, 0 );
    siz = constrain( siz, 1, width/4 );
    textSize( siz );
    //////// text transparency from distance | transparenz aus der distanz
    float col = map( dis, 0, width/2, 255, 0 );
    col = constrain( col, 0, 255 );
    fill( 255, 0, 0, col );
    //////// depict text | text darstellen
    text( my_chars[i], my_xs[i], my_ys[i] );
    //////// jiggle | ruckeln
    my_xs[i] += random( -1, 1 );
    my_ys[i] += random( -1, 1 );
  }
}

//////// interaction
void keyReleased() {
  if( key=='1' ) getArrays( getMin( my_size ) );                // re-run get min
  if( key=='2' ) getArrays( getNum( my_size ) );                // re-run get num
  if( key=='3' ) getArrays( getHex( my_size ) );                // re-run get hex
  if( key=='4' ) getArrays( getText( my_size, "de.txt" ) );     // re-run get german text
  if( key=='5' ) getArrays( getText( my_size, "en.txt" ) );     // re-run get english text
  if( key=='6' ) getArrays( getLorem( my_size ) );              // re-run get lorem
  if( keyCode==118 || keyCode==154 ) savePng();                 // f7 or print
}
