
//////// DesCode
//////// richard.dank@fh-joanneum.at
//////// http://richdank.com/theory/descode/
//////// clock-like conversion | uhrartige umformung

/*
 * //////// predefined arrays you need to work with
 * int my_size     : number of symbols that will be generated and placed
 * char[] my_chars : list, that contains the generated symbol
 * float[] my_xs   : the corresponding x-position of the symbol within the grid
 * float[] my_ys   : the corresponding y-position of the symbol within the grid
 */

//////// setup
void setup() {
  size( 1280, 720 );
  //getArrays( getMin( my_size ) );
  //getArrays( getNum( my_size ) );
  //getArrays( getHex( my_size ) );
  //getArrays( getText( my_size, "de.txt" ) );
  getArrays( getText( my_size, "en.txt" ) );
  //getArrays( getLorem( my_size ) );
}

//////// draw
void draw() {
  //simpleDemo();
  //circleDemo();
  //////// basic display modes and calculations | grundsaetzliche darstellung und berechnungen
  background( 255 );
  textAlign( CENTER, CENTER );
  textSize( width/64 );
  fill( 255*.9 );
  float delta_ang = TWO_PI / 128;
  //////// all the characters | alle zeichen
  for( int i=0; i<my_chars.length; i++ ) {
    //////// save state of transformation | aktuelle transformationen speichern
    pushMatrix();
    //////// apply multiple transformations | verschiedene transformationen anwenden
    translate( my_xs[i], my_ys[i] );
    rotate( delta_ang * int(my_chars[i]) );
    rotate( millis() * -.001 );
    //////// depict what's necessary | was notwendig ist darstellen
    text( int(my_chars[i]), 0, -width/96 );
    line( width/64, 0, -width/16, 0 );
    //////// reset transformations | transformationen zuruecksetzen
    popMatrix();
  }
}

//////// interaction
void keyReleased() {
  if( key=='1' ) getArrays( getMin( my_size ) );                // re-run get min
  if( key=='2' ) getArrays( getNum( my_size ) );                // re-run get num
  if( key=='3' ) getArrays( getHex( my_size ) );                // re-run get hex
  if( key=='4' ) getArrays( getText( my_size, "de.txt" ) );     // re-run get german text
  if( key=='5' ) getArrays( getText( my_size, "en.txt" ) );     // re-run get english text
  if( key=='6' ) getArrays( getLorem( my_size ) );              // re-run get lorem
  if( keyCode==118 || keyCode==154 ) savePng();                 // f7 or print
}
