
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// ! DO NOT EDIT unless you know exactly what you are doing ! //
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

//////////////////////////////// NECESSARY VARIABLES

//////// variables
int my_size = 144;
char[] my_chars; 
float[] my_xs, my_ys; 

//////////////////////////////// NECESSARY SETUP

//////// calc arrays
void getArrays( String line ) {
  //////// variables
  my_chars = new char[ 0 ]; 
  my_xs = new float[ 0 ]; 
  my_ys = new float[ 0 ]; 
  float len = line.length();
  float rat = float(width) / float(height);
  int x_len = int( ceil( sqrt(len*rat) ) );
  int y_len = int( ceil( len/x_len ) );
  float siz = float(width) / x_len;
  if( y_len*siz>height && true ) {
    y_len--;
    x_len = int( ceil( len/y_len ) );
    siz = float(width) / x_len;
  }
  println( "split into " + x_len + " columns in x and " + y_len + " lines in y" );
  println( "on a " + width + " by " + height + " screen, aspect ratio therefore " + rat );
  //////// calc
  for( int y=0; y<y_len; y++ ) {
    for( int x=0; x<x_len; x++ ) {
      int id = x + y*x_len;
      if( id>=len ) break;
      my_chars = append( my_chars, line.charAt(id) );
      my_xs = append( my_xs, (x+.5)*siz ); 
      my_ys = append( my_ys, (y+.5)*siz ); 
    }
  }
}

//////// generate random minimal symbol setup - 5 characters
String getMin( int len ) {
  //////// generate the full data
  String content = "";
  for( int i=0; i<len; i++ ) {
    content += int( random(5) );
  }
  //////// check gathered content
  println( "\n" + content );
  println( "\ngenerated random MINIMAL SYMBOL SETUP for content - " + content.length() + " characters [0-4] overall");
  //////// return data
  return content;
}

//////// generate random integer numbers - 10 characters
String getNum( int len ) {
  //////// generate the full data
  String content = "";
  for( int i=0; i<len; i++ ) {
    content += int( random(10) );
  }
  //////// check gathered content
  println( "\n" + content );
  println( "\ngenerated random INTEGER NUMBERS for content - " + content.length() + " characters [0-9] overall");
  //////// return data
  return content;
}

//////// generate random hexadecimal numbers - 16 characters
String getHex( int len ) {
  //////// generate the full data
  String content = "";
  for( int i=0; i<len; i++ ) {
    content += hex( int(random(16)), 1 );
  }
  //////// clean content
  content = content.toLowerCase();
  //////// check gathered content
  println( "\n" + content );
  println( "\ngenerated random HEXADECIMAL NUMBERS for content - " + content.length() + " characters [0-9,a-f] overall");
  //////// return data
  return content;
}

//////// read plaintext file - all characters present in the file
String getText( int len, String data ) {
  //////// read the full data
  String content = join( loadStrings(data), " " );
  //////// clean content
  content = content.substring( (int)random(content.length()-len) );
  content = content.substring( 0, len );
  //////// check gathered content
  println( "\n" + content );
  println( "\nread PLEINTEXT FILE " + data + " for content - " + content.length() + " characters [*] overall" );
  //////// return data
  return content;
}

//////// grab placeholder text "lorem ipsum" - 27 characters - simple version, needs to be online, NOT failsafe!
String getLorem( int len ) {
  //////// variables
  String data = "https://lipsum.com/feed/xml";
  String tag_beg = "<lipsum>";
  String tag_end = "</lipsum>";
  //////// read the full data
  String content = join( loadStrings(data), " " );
  //////// find the relevant section with regular expressions
  content = match( content, "(?<=" + tag_beg + ")(.*?)(?=" + tag_end + ")" ) [ 0 ];
  //////// clean content
  content = content.replace(".","").replace(",","");
  content = content.toUpperCase();
  content = content.substring( (int)random(content.length()-len) );
  content = content.substring( 0, len );
  //////// check gathered content
  println( "\n" + content );
  println( "\ngrabbing random PLACEHOLDER TEXT at " + data + " for content - " + content.length() + " characters [A-Z, ] overall" );
  //////// return data
  return content;
}

//////////////////////////////// USEFUL FUNCTIONS

//////// draw simple demo output
void simpleDemo() {
  //////// depiction
  background( 255 );
  textAlign( CENTER, CENTER );
  textSize( height/4 );
  fill( 0, 127 );
  for( int i=0; i<my_chars.length; i++ ) {
    text( my_chars[i], my_xs[i], my_ys[i] );
  }
}

//////// draw circle demo output
void circleDemo() {
  //////// variables
  int len = my_chars.length;
  float siz = my_xs[1] - my_xs[0];
  //////// depiction
  background( 255 );
  textAlign( CENTER, CENTER );
  for( int i=0; i<len; i++ ) {
    stroke( 0 );
    fill( 255*.7 );
    textSize( siz/8 );
    text( i, my_xs[i]+.3*siz, my_ys[i]+.2*siz );
    stroke( 0 );
    fill( 0 );
    textSize( siz/2 );
    text( my_chars[i], my_xs[i], my_ys[i] );
    if( my_chars[i]=='0' || my_chars[i]==' ' ) {
      noFill();
      circle( my_xs[i], my_ys[i], siz );
    }
  }
}

//////// save image
void savePng() {
  //////// naming
  println( "    #### starting to export png image ..." );
  String png_name = "pngs/" + getClass().getSimpleName() + "_" + str(year()).substring(2) + nf(month(), 2) + nf(day(), 2) + "_" + nf(hour(), 2) + nf(minute(), 2) + nf(second(), 2);
  //////// saving
  save( png_name  + ".png" );
  println( png_name + ".png" + " saved!\n" );
}
