
//////// DesCode
//////// richard.dank@fh-joanneum.at
//////// http://richdank.com/theory/descode/
//////// traveling circles | bewegte kreise

/*
 * //////// predefined arrays you need to work with
 * int my_size     : number of symbols that will be generated and placed
 * char[] my_chars : list, that contains the generated symbol
 * float[] my_xs   : the corresponding x-position of the symbol within the grid
 * float[] my_ys   : the corresponding y-position of the symbol within the grid
 */

//////// setup
void setup() {
  size( 1280, 720 );
  //getArrays( getMin( my_size ) );
  //getArrays( getNum( my_size ) );
  //getArrays( getHex( my_size ) );
  //getArrays( getText( my_size, "de.txt" ) );
  getArrays( getText( my_size, "en.txt" ) );
  //getArrays( getLorem( my_size ) );
}

//////// draw
void draw() {
  //simpleDemo();
  //circleDemo();
  //////// semi-transparent background | halbtransparenter hintergrund
  noStroke();
  fill( 255, 255*.2 );
  rect( 0, 0, width, height );
  //////// all the characters | alle zeichen
  for( int i=0; i<my_chars.length; i++ ) {
    int sequence = int(my_chars[i]);
    int fac = frameCount%sequence;
    textAlign( CENTER, CENTER );
    textSize( sequence-fac );
    fill( 0, 255, 127, 255*.05 );
    float x = map( fac, 0, sequence, my_xs[i], width/2 );
    float y = map( fac, 0, sequence, my_ys[i], height/2 );
    //////// depict text, if desired | text darstellen, falls gewuenscht
    text( my_chars[i], x, y );
    stroke( 0, 255, 127, 255*.5 );
    noFill();
    circle( x, y, sequence-fac );
  }
}

//////// interaction
void keyReleased() {
  if( key=='1' ) getArrays( getMin( my_size ) );                // re-run get min
  if( key=='2' ) getArrays( getNum( my_size ) );                // re-run get num
  if( key=='3' ) getArrays( getHex( my_size ) );                // re-run get hex
  if( key=='4' ) getArrays( getText( my_size, "de.txt" ) );     // re-run get german text
  if( key=='5' ) getArrays( getText( my_size, "en.txt" ) );     // re-run get english text
  if( key=='6' ) getArrays( getLorem( my_size ) );              // re-run get lorem
  if( keyCode==118 || keyCode==154 ) savePng();                 // f7 or print
}
